// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from qb_softhand_industry_msgs:msg/ResourceData.idl
// generated code does not contain a copyright notice

#ifndef QB_SOFTHAND_INDUSTRY_MSGS__MSG__DETAIL__RESOURCE_DATA__STRUCT_HPP_
#define QB_SOFTHAND_INDUSTRY_MSGS__MSG__DETAIL__RESOURCE_DATA__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__qb_softhand_industry_msgs__msg__ResourceData __attribute__((deprecated))
#else
# define DEPRECATED__qb_softhand_industry_msgs__msg__ResourceData __declspec(deprecated)
#endif

namespace qb_softhand_industry_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ResourceData_
{
  using Type = ResourceData_<ContainerAllocator>;

  explicit ResourceData_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->position = 0.0;
      this->velocity = 0.0;
      this->effort = 0.0;
      this->command = 0.0;
    }
  }

  explicit ResourceData_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->position = 0.0;
      this->velocity = 0.0;
      this->effort = 0.0;
      this->command = 0.0;
    }
  }

  // field types and members
  using _name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _name_type name;
  using _position_type =
    double;
  _position_type position;
  using _velocity_type =
    double;
  _velocity_type velocity;
  using _effort_type =
    double;
  _effort_type effort;
  using _command_type =
    double;
  _command_type command;

  // setters for named parameter idiom
  Type & set__name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__position(
    const double & _arg)
  {
    this->position = _arg;
    return *this;
  }
  Type & set__velocity(
    const double & _arg)
  {
    this->velocity = _arg;
    return *this;
  }
  Type & set__effort(
    const double & _arg)
  {
    this->effort = _arg;
    return *this;
  }
  Type & set__command(
    const double & _arg)
  {
    this->command = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    qb_softhand_industry_msgs::msg::ResourceData_<ContainerAllocator> *;
  using ConstRawPtr =
    const qb_softhand_industry_msgs::msg::ResourceData_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<qb_softhand_industry_msgs::msg::ResourceData_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<qb_softhand_industry_msgs::msg::ResourceData_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      qb_softhand_industry_msgs::msg::ResourceData_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<qb_softhand_industry_msgs::msg::ResourceData_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      qb_softhand_industry_msgs::msg::ResourceData_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<qb_softhand_industry_msgs::msg::ResourceData_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<qb_softhand_industry_msgs::msg::ResourceData_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<qb_softhand_industry_msgs::msg::ResourceData_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__qb_softhand_industry_msgs__msg__ResourceData
    std::shared_ptr<qb_softhand_industry_msgs::msg::ResourceData_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__qb_softhand_industry_msgs__msg__ResourceData
    std::shared_ptr<qb_softhand_industry_msgs::msg::ResourceData_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ResourceData_ & other) const
  {
    if (this->name != other.name) {
      return false;
    }
    if (this->position != other.position) {
      return false;
    }
    if (this->velocity != other.velocity) {
      return false;
    }
    if (this->effort != other.effort) {
      return false;
    }
    if (this->command != other.command) {
      return false;
    }
    return true;
  }
  bool operator!=(const ResourceData_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ResourceData_

// alias to use template instance with default allocator
using ResourceData =
  qb_softhand_industry_msgs::msg::ResourceData_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace qb_softhand_industry_msgs

#endif  // QB_SOFTHAND_INDUSTRY_MSGS__MSG__DETAIL__RESOURCE_DATA__STRUCT_HPP_
